﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using GrapeCity.Windows.SpreadSheet.Data;


namespace SpreadSLContextMenu_CS
{
    public partial class MainPage : UserControl
    {
        ContextMenu cmenu = null;
        MenuItem mItem;
        public MainPage()
        {
            InitializeComponent();
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            gcSpreadSheet1.ActiveSheet.Cells[0, 0, 3, 3].Text = "test";

            gcSpreadSheet1.MouseRightButtonDown += new MouseButtonEventHandler(gcSpreadSheet1_MouseRightButtonDown);
 
        }

        void gcSpreadSheet1_MouseRightButtonDown(object sender, MouseButtonEventArgs e)
        {
            //throw new NotImplementedException();
            e.Handled = true;

            cmenu = new ContextMenu();
            mItem = new MenuItem();
            mItem.Header = "Number Cell";
            cmenu.Items.Add(mItem);
            mItem.Click += new RoutedEventHandler(mItem_Click);

            mItem = new MenuItem();
            mItem.Header = "Date Cell";
            cmenu.Items.Add(mItem);
            mItem.Click += new RoutedEventHandler(mItem_Click);

            mItem = new MenuItem();
            mItem.Header = "Cut";
            cmenu.Items.Add(mItem);
            mItem.Click += new RoutedEventHandler(mItem_Click);

            mItem = new MenuItem();
            mItem.Header = "Copy";
            cmenu.Items.Add(mItem);
            mItem.Click += new RoutedEventHandler(mItem_Click);

            mItem = new MenuItem();
            mItem.Header = "Paste";
            cmenu.Items.Add(mItem);
            mItem.Click += new RoutedEventHandler(mItem_Click);

            cmenu.IsOpen = true;
            cmenu.HorizontalOffset = e.GetPosition(LayoutRoot).X;
            cmenu.VerticalOffset = e.GetPosition(LayoutRoot).Y;
  
        }

        void mItem_Click(object sender, RoutedEventArgs e)
        {
            //throw new NotImplementedException();
            MenuItem menuItem = (MenuItem)sender;
            switch (menuItem.Header.ToString())
            {
                case "Number Cell":

                    gcSpreadSheet1.ActiveSheet.ActiveCell.Formatter = new GrapeCity.Windows.SpreadSheet.Data.GeneralFormatter(GrapeCity.Windows.SpreadSheet.Data.FormatMode.StandardNumericMode, "c");
                    break;
                case "Date Cell":
                    gcSpreadSheet1.ActiveSheet.ActiveCell.Formatter = new GrapeCity.Windows.SpreadSheet.Data.GeneralFormatter(GrapeCity.Windows.SpreadSheet.Data.FormatMode.StandardDateTimeMode, "M");
                    break;
                case "Cut":
                    foreach (CellRange cellRange in gcSpreadSheet1.ActiveSheet.Selections)
                    {
                        CellRange range = GetActualCellRange(cellRange, gcSpreadSheet1.ActiveSheet.RowCount, gcSpreadSheet1.ActiveSheet.ColumnCount);
                        gcSpreadSheet1.View.ClipboardCut(range);

                    }

                    break;
                case "Copy":
                    foreach (CellRange cellRange in gcSpreadSheet1.ActiveSheet.Selections)
                    {
                        CellRange range = GetActualCellRange(cellRange, gcSpreadSheet1.ActiveSheet.RowCount, gcSpreadSheet1.ActiveSheet.ColumnCount);
                        gcSpreadSheet1.View.ClipboardCopy(range);


                    }

                    break;
                case "Paste":
                    foreach (CellRange cellRange in gcSpreadSheet1.ActiveSheet.Selections)
                    {
                        CellRange range = GetActualCellRange(cellRange, gcSpreadSheet1.ActiveSheet.RowCount, gcSpreadSheet1.ActiveSheet.ColumnCount);
                        gcSpreadSheet1.View.ClipboardPaste(range);
                    }

                    break;
                default:
                    break;
            }
            cmenu.IsOpen = false;

        }

        private CellRange GetActualCellRange(CellRange cellRange, int rowCount, int columnCount)
        {
            if (cellRange.Row == -1 && cellRange.Column == -1)
            {
                return new CellRange(0, 0, rowCount, columnCount);
            }
            else if (cellRange.Row == -1)
            {
                return new CellRange(0, cellRange.Column, rowCount, cellRange.ColumnCount);
            }
            else if (cellRange.Column == -1)
            {
                return new CellRange(cellRange.Row, 0, cellRange.RowCount, columnCount);
            }

            return cellRange;
        }
    }
}
